Fri Apr  7 15:14:43 PDT 2017  Phil Nelson <philnelson@acm.org>
	* NEWS: update for 1.07.1 and 1.4.1
	* FAQ: add a couple new FAQs.
	* doc/bc.1: change doucumentation of length() and correctly
	  represent newline.
	* doc/bc.texi: change doucumentation of length()


Fri Apr  7 13:43:31 PDT 2017 Ken Pizzini <ken@gnu.org>
	* bc/configure.ac: update dc version to 1.4.1;
	  update dc copyright year list

Fri Apr  7 13:14:41 PDT 2017 Phil Nelson <philnelson@acm.org>
	* bc/Makefie.am: Do a different fix for parallel make issues.

Fri Apr  7 00:11:49 PDT 2017 Ken Pizzini <ken@gnu.org>
	* dc/eval.c, dc/numeric.c: take more care to never pass
	  a sign-extended char to the <ctype.h> isXXX() functions.
	  Thanks to a NetBSD compiler warning for flagging this.

Thu Apr  6 22:47:46 PDT 2017 Phil Nelson <philnelson@acm.org>
	* bc/execute.c: More tweaks to fix for read() problems.
	* bc/Makefile.am: Attempt to fix parallel make problems.

Thu Apr  6 16:39:25 PDT 2017 Phil Nelson <philnelson@acm.org>
	* bc/execute.c: Correct leading space problem caused by last fix.
	* bc/configure.ac: version to 1.07.1

Thu Apr  6 15:37:22 PDT 2017 Phil Nelson <philnelson@acm.org>
	* bc/execute.c: Correct input_char for base 36 input.
	* doc/bc.1: Update documentation for base 36 input.
	* doc/bc.texi: Update documentation for base 36 input.

Thu Apr  6 14:26:27 PDT 2017 Ken Pizzini <ken@gnu.org>
	* dc/eval.c: The 'Q' command "fix" of 2016-09-24 was incorrect.
	  It fixed a reported bug, but introduced a regression for other
	  existing (and correct) code.  Let's try this again (sigh).

Thu Apr  6 13:11:15 PDT 2017 Ken Pizzini <ken@gnu.org>
	* dc/dc.c: bah, nevermind; just re-disovered commit of
	  Oct 26, 2013 where the setvbuf() was rendered unnecessary
	  by introduction of explicit fflush()-es.

Thu Apr  6 13:11:15 PDT 2017 Ken Pizzini <ken@gnu.org>
	* dc/dc.c: re-instate setvbuf() call that got lost

Mon Jan 16 14:30:00 PDT 2017 Phil Nelson <philnelson@acm.org>
	* Updated copyright to 2017.

Sun Oct 23 16:38:05 PDT 2016 Ken Pizzini <ken@gnu.org>
	* dc/eval.c: dc_system() already eats up to (and including)
	  a trailing newline, so don't fall-through in dc_evalstr()'s
	  DC_SYSTEM case to DC_COMMENT's skip_past_eol() call,
	  as that would unexpectedly require eating a second newline.
	  Thanks to David José for noticing and reporting the bug.

Thu Oct 20 03:11:43 PDT 2016 Ken Pizzini <ken@gnu.org>
	* doc/dc.texi: fix some typos.

Mon Oct 17 00:28:50 PDT 2016 2016 Ken Pizzini <ken@gnu.org>
	* doc/dc.1, doc/dc.texi: document the new default-to-zero
	  of the 'l' command.

Mon Oct 17 00:02:11 PDT 2016 Ken Pizzini <ken@gnu.org>
	* doc/dc.1, doc/dc.texi: be more careful in specifying how
	  the precision of the result of the "v" (square root)
	  command is determined.
	  Thanks to David José for pointing out that the old text
	  underspecified this.

Sun Oct 16 23:43:05 PDT 2016 Ken Pizzini <ken@gnu.org>
	* dc/stack.d: return a 0 (zero value; instead of reporting an error)
	  for the "l" command when the named register stack is empty.
	  Thanks to David José for the suggestion.  (This is a useful default
	  value, and make GNU dc more compatable with BSD dc and Bell Labs
	  version 7 dc.)

Wed Sep 28 13:24:50 PDT 2016 Ken Pizzini <ken@gnu.org>
	* dc/eval.c, doc/dc.1, doc/dc.texi: update copyright dates

Sat Sep 24 16:04:01 PDT 2016 Ken Pizzini <ken@gnu.org>
	* dc/dc.c, dc/eval.c: yesterday's fix for 'Q' created a
	  new bug for the 'q' command; this fresh (and simpler!)
	  fix does the right thing.  (Thanks again to Paul Rayner.)

Fri Sep 23 22:49:17 PDT 2016 Ken Pizzini <ken@gnu.org>
	* dc/dc.c: don't prematurely exit from stack-unwinding 'Q'
	  command
	* dc/eval.c: ensure that DC_FAIL API value does not
	  collide with any internal dc_status code
	* doc/dc.1, doc/dc.texi: clarify that 'Z' command reports
	  on digits in decimal representation in number (as opposed
	  to ambiguous, perhaps "o"base, digits).
	* (Bugs reported by Paul Rayner; thanks.)

Mon Feb 29 15:56:00 PST 2016 Phil Nelson <philnelson@acm.org>
	* Makefile.am, bc/Makefile.am: update to not include
	libmath.h in distribution.
	* configure.ac: update copyright with 2016

Mon Feb 29 13:06:00 PST 2016 Phil Nelson <philnelson@acm.org>
	* bc/Makefile: Add $(LIBBC) as dependency to fbc so
	libmath.h gets correctly built.  sbc also needed it.

Mon Feb 29 12:05:00 PST 2016 Phil Nelson <philnelson@acm.org>
	* bc/util.c, bc.y: Fix two memory leaks submitted to
	Gentoo by Bruce Dubbs.

Tue Jan 19 22:10:10 PST 2016 Phil Nelson <philnelson@acm.org>
	* bc/{execute.c, load.c, main.c, proto.h, scan.l, storage.c, util.c},
	  lib/number.c: Update copyrights, remove old style function
	declarations, remove _PROTOTYPE macros, update to GPL V3.
	Various other code cleanups.

Mon Jan 11 14:01:32 PST 2016 Ken Pizzini <ken@gnu.org>
	* doc/dc.texi: fix typo (reported by Avinash Sonawane)

Mon May 11 16:40:31 PDT 2015 Ken Pizzini <ken@gnu.org>
	* dc/stack.c: catch the case of an empty value on top of
	  a register stack (i.e., the stack entry is first created by
	  an array store on a previously unallocated register)
	  as a normal run-time error, rather than an abort() condition.
	  (Bug reported by Hanno Böck, who found it during fuzz testing.)

Mon Jan 26 22:30:00 PST 2015 Phil Nelson <philnelson@acm.org>
	* bc/execute.c, load.c, scan.l, storage.c:  Extend input
	  base to allow for base 36 with Z being the largest
	  input digit.  Now, ZZZZZ will be the largest 5 digit
	  number given the allowable bases.

Mon Jan 26 21:34:00 PST 2015 Phil Nelson <philnelson@acm.org>
	* various: updated copyright on all GPL licence comments.

Mon Jan 19 00:03:05 PST 2015 Ken Pizzini <ken@gnu.org>
	* News: brought up-to-date for dc-1.07 release
	* README: bump relase number
	* bootstrap.sh: let the autotools give us as much guidance as they can
	* configure.ac: modernize, based on autotools' -Wall suggestions;
	  update copyright years; GPL version 3; use URL to get copy of GPL,
	  instead of snail-mail address; version bump (for both dc and bc);
	  simplify the libedit/readline/flex cross-check logic
	* dc/eval.c: update copyright years

Thu Nov 27 22:17:17 PST 2014 Ken Pizzini <ken@gnu.org>
	* dc/eval.c: dc_evalstr() incorrectly used len-1, to omit counting the
	  closing ']', unconditionally, even when string parsing terminated
	  prematurely (end-of-string reached before closing ']' was found).
	  This is wrong in general, and painfully wrong when len==0.
	  (Bug reported by Hanno Böck, who found it during fuzz testing.)

Fri Oct 31 13:50:18 PDT 2014 Ken Pizzini <ken@gnu.org>
	* dc/eval.c: dc_evalstr() was inappropriately/prematurely returning
	  when the top-of-stack was a number.  (Bug reported by Saito Takaaki.)

Sun Sep  7 15:20:29 PDT 2014 Ken Pizzini <ken@gnu.org>
	* dc/eval.c: the '!' command was incorrectly interacting with stdin
	  rather than fp (the current input stream) when reading the
	  shell command to be executed.  (Bug reported by Dario Niedermann.)

Sat Oct 26 14:54:37 PDT 2013 Ken Pizzini <ken@gnu.org>
	* doc/dc.1, doc/dc.texi: Updated copyright dates.

Sat Oct 26 14:54:37 PDT 2013 Ken Pizzini <ken@gnu.org>
	* doc/dc.1, doc/dc.texi: Documented the "R" (rotate stack) command.

Sat Oct 26 14:39:10 PDT 2013 Ken Pizzini <ken@gnu.org>
	* dc/dc-proto.h, dc/dc.c, dc/eval.c, dc/misc.c, dc/numeric.c,
	  dc/stack.c, dc/string.c:
	  Explicitly flush output, instead of requesting line buffering,
	  as the user may be emitting a prompt (without a trailing newline)
	  within an inferior process.  Also, clean-up/simplify related code.

Fri Jun 29 13:14:18 PDT 2012 Ken Pizzini <ken@gnu.org>
	* dc/eval.c dc/stack.c, dc/dc-proto.h:
	  Implement 'R', general stack rotation command

Thu Mar  7 21:55:47 PST 2013 Phil Nelson <phil@cs.wwu.edu>
	* configure.ac, bc/Makefile.am, dc/Makefile.am, lib/Makefile.am:
	  Update automake definitions for newer versions of automake.
	  Tested with version 1.13.1.

Tue Nov  2 11:09:00 2010 Phil Nelson <phil@cs.wwu.edu>
	* bc/{bc.y, execute.c, load.c, main.c, proto.h, scan.l,
	  util.c}:  Add a bc_exit() routine that resets the editline
	  state in one place to exit.  Removed editline state reset
	  in other places.

Sun Mar 21 11:42:16 2010 Ken Pizzini <ken@gnu.org>
	* dc/eval.c: take a more nuanced approach to handling SIGINT

Thu May 22 17:28:07 2008 Ken Pizzini <ken@gnu.org>
	* All: update copyright statements and license statements:
	  the code is now released under GPL-3, and documentation
	  under FDL-1.2.
	* configure.in, Makefile.am, bootstrap.sh; h/* lib/* gnulib/* m4/*:
	  import portability code via gnulib-tools
	* bc/bc.y, bc/sbc.y, bc/execute.c, bc/load.c, bc/main.c, bc/proto.h,
	  bc/scan.l, bc/util.c: detect, report (if possible), and exit with
	  error if any I/O errors are encountered
	* doc/dc.texi: clean-up preamble (using more modern texinfo macros)

Mon Sep  4 19:27:49 2006 Ken Pizzini <ken@gnu.org>
	* configure.in: re-factor how version numbers are handled; add errno.h
	  and strtol() checks; add doc-texi-ver.incl output
	* bc/bcdefs.h: Prefer <string.h> over <strings.h>
	* bc/execute.c, bc/load.c, bc/main.c, bc/proto.h, bc/scan.l,
	  bc/storage.c, bc/util.c, bc/warranty.c: De-lint some with "const"
	  declarations, "static" declarations, and un-shadowing a few global
	  variables and functions
	* dc/dc.c: add "static" keyword on flush_okay() function declaration,
	  just for good hygene
	* dc/numeric.c: Reworked to avoid breaking C99 type-punning rules

Wed Jun 14 08:21:17 2006 Ken Pizzini <ken@gnu.org>
	* dc/numeric.c (dc_int2data): rework code so that C99 compilers
	  stop whining about the type punning
	* dc/dc.c (flush_okay): add "static" keyword as a matter of good
	  coding hygene

Sun Jun 11 21:40:37 2006 Ken Pizzini <ken@gnu.org>
	* doc/bc.1: strip release version information which is not being
	  automatically kept up-to-date
	* doc/dc.1: don't capitalize Dc or DC

Sun Jun 11 09:07:26 2006 Ken Pizzini <ken@gnu.org>
	* doc/bc.texi, doc/dc.texi, doc/texi-ver.incl.in, doc/Makefile.am:
	  make version text in texinfo-based documentation auto-derive from
	  configure.in
	* configure.in: update to use more modern automake/autoconf
	  directives; factor out version numbers so that AC_SUBST and
	  AC_OUTPUT kcan be used to create doc/texi-ver.incl
	* doc/Makefile.am: automake does (now) have a mechanism to
	  auto-include declared man pages in the dist tarball, so
	  remove FIXME block

Sun Jun 11 03:04:18 2006 Ken Pizzini <ken@gnu.org>
	* lib/Makefile.am: testmul, specialnumber, multidigits.h are
	  autogenerated by special request (only), and "make clean" should
	  remove them
	* lib/testmul.c: CLOCKS_PER_SEC is typically a "long" value, so make
	  test_time wide enough to hold it; add missing #include directives
	* lib/number.c: silly warning clean-up:
	  + declare rt_warn() and rt_error() to take a CONST char* first
	    argument
	  + neither _bc_rec_mul() nor _bc_simp_mul() use the full_scale
	    argument, so remove it in the function definitions and invocations
	  + some C libraries define an index() function; use a different index
	    variable name to avoid gratuitous namespace shadowing

Sun Jun  4 13:56:58 2006 Ken Pizzini <ken@gnu.org>
	* doc/dc.texi: document new DC_LINE_LENGTH variable; mention
	  traditional dc's handling of P with a numeric input
	* dc/dc.c (flush_okay, main): make code detecting and handling
	  write errors cleaner

Sun Jun  4 12:26:00 2006 Phil Nelson <phil@cs.wwu.edu>
	* bc/main.c: Make sure 3 is the minimum line length.
	* doc/bc.1, doc/bc.texi: Document the BC_LINE_LENGTH of 0 feature.

Sun Jun  4 04:41:28 2006 Ken Pizzini <ken@gnu.org>
	* dc/dc.c (main): fflush() isn't enough: also check that fclose()
	  does not return an error before exiting with EXIT_SUCCESS

Sun Jun  4 04:15:15 2006 Ken Pizzini <ken@gnu.org>
	* dc/dc.c, dc/eval.c: detect, report (if possible), and exit with error
	  if any I/O errors are encountered

Sun Jun  4 02:27:41 2006 Ken Pizzini <ken@gnu.org>
	* bc/main.c, bc/util.c: allow a BC_LINE_LENGTH of zero as a
	  special-case, meaning "don't ever wrap lines"
	* dc/numeric.c, configure.in: add support for a DC_LINE_LENGTH
	  variable, with a value of zero meaning "don't ever wrap lines"

Fri May  5 18:45:17 2006 Ken Pizzini <ken@gnu.org>
	* dc/dc.c (try_file): S_ISREG() test was inverted! :-(
	  (how very embarrassing)

	* configure.in: the "if test" -> "case" conversion in the last commit
	  translated the handling of flex incorrectly; fixed

	* src/scan.l: readline versions 4.2 and up give their own prototype
	  for readline() in readline.h, which conflicts with the one that is
	  in scan.l, so just do without the prototype in scan.l (if someone
	  needs to backport to a very old version of readline, they should be
	  able to handle adding the prototype back in themselves)

	* doc/bc.texi: use of @var{} in @item causes capitalization on output,
	  which is wrong, and furthermore the use of @var{} for e() and j() is
	  also inconsistent with how the other math functions are formatted

Sat Apr 29 05:02:15 2006 Ken Pizzini <ken@gnu.org>
	* configure.in: The "true" branch of AC_ARG_WITH needed to
	  be conditionalized on the value of $withval (thanks to Mike
	  Frysinger of Gentoo for pointing this out); prefer using
	  "case" over "if test" in shell string-match conditionals;
	  make use of AC_HELP_STRING; added copyright block; clean
	  out old "dnl"'d directives

Sat Apr 29 04:02:23 2006 Ken Pizzini <ken@gnu.org>
	* dc/dc.c (try_file): fix typo in S_ISFIFO conditional

	* doc/bc.1, doc/bc.texi, doc/dc.1, doc/dc.texi: make some
	  formatting clean-up (minor)

Wed Apr 26 15:38:32 2006 Ken Pizzini <ken@gnu.org>
	* dc/dc.c (try_file): rework special-file detection so that
	  friendlier error messages can be given for the most common
	  error of this class (i.e., the "dc directory" typo).

Thu Apr 20 17:45:46 2006 Ken Pizzini <ken@gnu.org>
	* configure.in: Newer versions of flex (such as ver. 2.5.33)
	  don't seem to like an argument of "-I8" anymore ("option `I'
	  doesn't allow an argument"), so split that into "-I -8".

Wed Mar 29 05:09:14 2006 Ken Pizzini <ken@gnu.org>
	* dc/string.c, dc/misc.c, dc/stack.c, dc/dc.c, dc/eval.c, dc/array.c:
	  Make splint (http://www.splint.org/) happier by making all
	  comparisons to 0 and NULL explicit, and adding some explicit casts
	  that aren't strictly necessary.  (But I'm omitting from this commit
	  various splint annotations that just serve to make the code ugly.)

Tue Mar 28 13:36:00 2006 Phil Nelson <phil@cs.wwu.edu>
	* bc/util.c: Move code so size checks are before use.

	* doc/bc.1: Quote .IP argument.

Tue Mar 28 12:09:38 2006 Ken Pizzini <ken@gnu.org>
	* dc/dc.c (try_file):  Added file type detection to ignore some
	  special files (particularly directories and block files), because
	  several people have asked that a typo for "cd" not fail silently.

	* configure.in: add detection of fstat() to determine how the
	  above detection should be implemented.

Wed Mar 15 9:50:00 2006 Phil Nelson <phil@cs.wwu.edu>
	* lib/getopt.c:  Added a define to disable/enable
	  gettext support.  May need to be deleted later
	  when gettext is fully supported. 

Mon Mar 13 13:57:00 2006 Phil Nelson <phil@cs.wwu.edu>
	* bc/bc.y: Remove second call to lookup() in a rule.
	  Removes a free'd twice bug.

Sat May 28 05:42:01 2005 Ken Pizzini <ken@gnu.org>

	* doc/dc.1, doc/dc.texi: add verbage about the need to use
	  upper-case letters for ibase>10 (bug reported by "TJIC").

Fri May 20 ??:??:?? 2005 Ken Pizzini <ken@gnu.org>
	* lib/getopt.c, lib/getopt1.c: Update to more recent versions.

Fri May 27 09:19:21 2005 Ken Pizzini <ken@gnu.org>

	* dc/eval.c: abstract out skip_past_eol() function to handle comments

Fri May 27 07:30:52 2005 Ken Pizzini <ken@gnu.org>

	* dc/numeric.c (dc_numlen), doc/dc.1, dc.texi: correct Z command
	  to match historical meaning

Fri May 27 06:54:19 2005 Ken Pizzini <ken@gnu.org>

	* dc/eval.c: ignore trailing comments in tail-recursion detection

	* dc/eval.c, doc/dc.texi: finally fix dc to trap interrupts,
	  aborting pending macros but not exiting

Fri May 27 03:37:30 2005 Ken Pizzini <ken@gnu.org>

	* dc/numeric.c: Address Debian bug #221781: values exceeding
	  a C "long" don't play well with k/i/o/a/Q/:/; commands.
	  Adding a diagnostic, and returning a "more bogus" value than
	  zero, for this situation.

Thu May 26 09:03:57 2005 Ken Pizzini <ken@gnu.org>

	* dc/eval.c:
	  1) fix tail recursion to also work for 'x' and '?' commands
	  2) fix tail recursion to ignore trailing spaces in the current
	     invocation string when determining if tail recursion is
	     appropriate
	  3) remove a couple of misleading and/or meaningless comments
	  4) add documentation for stdin_lookahead, since the code is far
	     from transparent about its purpose and usage
	  5) simplify ibase conditional by rearranging branches

Wed May 25 21:20:08 2005 Ken Pizzini <ken@gnu.org>

	* dc/array.c dc/dc-proto.h dc/dc-regdef.h dc/dc.c dc/dc.h
	  dc/eval.c dc/numeric.c: whitespace cleanup

Wed May 25 19:48:26 2005 Ken Pizzini <ken@gnu.org>

	* COPYING COPYING.LIB dc/dc-proto.h dc/dc-regdef.h dc/dc.h
	  dc/array.c dc/dc.c dc/eval.c dc/misc.c dc/numeric.c dc/stack.c
	  dc/string.c doc/dc.1 doc/dc.texi:
	  update FSF address in copyright notices

Wed May 25 19:39:46 2005 Ken Pizzini <ken@gnu.org>

	* dc/stack.c: If a register is used for an array, its corresponding
	  stack could be auto-created in the DC_UNINITIALIZED state; handle
	  this situation gracefully.  Thanks to Ben Collerson
	  (http://bur.st/~benc/) for the bug report.

Wed Dec 31 07:26:00 2003 Phil Nelson  <phil@cs.wwu.edu>

	* Makefile.am: add depcomp

	* {bc,dc,lib}/Makefile.am: CFLAGS -> AM_CFLAGS, YFLAGS -> AM_YFLAGS

	* bc/*: consistent copyright

Fri May  9 21:52:46 2003 Ken Pizzini <ken@gnu.org>

	* dc/dc-proto.h dc/dc.c dc/eval.c: add tail-recursion optimization

	* dc/numeric.c: clean up handling of conditional includes/defines;
	  editorial fix to comment; trivial (indentation, mostly) clean-up of
	  out_char() function [gratuitious; commit was accidental and I'm
	  adding this note to a replacement log message]

	* dc/misc.c: fixed spelling and grammatical errors in comment

	* dc/dc-regdef.h: simplify the handling of UCHAR_MAX/DC_REGCOUNT
	  defaults

Thu Apr 17 16:25:35 2003 Phil Nelson  <phil@cs.wwu.edu>

	* bc/{execute.c, proto.h, util.c}: char -> int in a few
	  places dealing with isdigit and getchar(), updated copyright

	* bc/main.c: minor formatting changes, updated copyright

	* bc/libmath.b, doc/{bc.1,bc.texi}: updated copyright

Mon Mar 31 22:19:00 2003  Phil Nelson  <phil@cs.wwu.edu>

	* doc/{bc.1,bc.texi} Fix a couple of typos.
	* bc/main.c: exit value changed when exiting from interrupt.

Tue Mar 4 09:38:00 2003  Phil Nelson  <phil@cs.wwu.edu>

	* bc/libmath.b: Add one level recursion to each function to
	  get ibase set to 10 (decimal) if called with other ibases.

Mon Nov 11 09:15:00 2002  Phil Nelson  <phil@cs.wwu.edu>

	* doc/{bc.1,bc.texi} Fix documentation about array parameters.

Tue Mar 19 11:22:06 2002  Phil Nelson  <phil@cs.wwu.edu>

	* bc/{bc.y,bcdefs.h,scan.l}: Add void functions.
	* doc/{bc.1,bc.texi}:  Document void functions.
	* bc/util.c:  Fix bug in AVL routines.

Wed May 23 08:40:00 2001  Phil Nelson  <phil@cs.wwu.edu>

	* Makefile.am, */Makefile.am, configure.in: Add gcc specific
	  flags only if using gcc.
	* bc/{bc.y,sbc.y,bcdefs.h,const.h,execute.c,global.[ch],proto.h,
	      main.c,util.c}:  Removal of buffer overflow, new extern
	  and initialization code. New dynamic buffer manipulation.
	* bc/load.c: correct char extraction.
	* bc/storage.c: correct expansion of variables and arrays.

Sun May 13 19:29:43 2001 Ken Pizzini <ken@gnu.org>

	* dc/array.c: minor optimization: stop scanning array entry indicies
	  if we step beyond the target index

Sun May 13 19:09:31 2001 Ken Pizzini <ken@gnu.org>

	* dc/dc.c: traditional dc implementations drop into reading stdin
	  after processing command-line files; defer to tradition

Sat Feb 17 22:41:14 2001  Phil Nelson  <phil@cs.wwu.edu>

	* bc/{main.c} Add case 0 for long options that set variables.
	  Correct spelling in usage statement.

Mon Jan 22 18:33:43 2001  Phil Nelson  <phil@cs.wwu.edu>

	* bc/main.c: Make sure signal code doesn't stomp on errno.
	* bc/load.c: Make save_addr in load_code() static since it
	  is now possible to call load_code() multiple times in a single
	  function.

Fri Jan 19 10:33:13 2001  Phil Nelson  <phil@cs.wwu.edu>

	* bc/{main.c,execute.c}: Don't use stdio calls in signal
	  handlers.  Call write directly and move code.

Wed Jan 10 11:33:51 2001  Phil Nelson  <phil@cs.wwu.edu>

	* lib/getopt.c: Include string.h if available.
	  lib/number.c: (bcmath change) Include string.h if available.

Wed Sep 27 17:19:48 2000  Phil Nelson  <phil@cs.wwu.edu>

	* doc/bc.texi: Added new file. Mainly translated from bc.1
		       by Brian Youmans.
	  doc/bc.1: Minor changes made as part of reviewing bc.texi.

Wed Sep 20 11:45:00 2000  Phil Nelson  <phil@cs.wwu.edu>

	* bc/bc.y:  Added a comment on the meanings of lvals.

Wed Sep 13 11:40:24 2000  Phil Nelson  <phil@cs.wwu.edu>

	* bc/main.c: add --interactive to long options.
	  bc/bc.1: add -i/--interactive to doc.
	  MANY: Update FSF address and Phil's e-mail.

Tue Sep 12 13:58:16 2000  Phil Nelson  <phil@cs.wwu.edu>

	* NEWS: update for recent changes.
	  bc/bc.y: remove required parens around return expression.
	  doc/bc.1: update for recent changes.

Fri Sep  8 10:20:01 2000  Phil Nelson  <phil@cs.wwu.edu>

	* bc/Makefile.am, dc/Makefile.am, lib/Makefile.am:
	    Compile with unsigned characters.
	  bc/main.c: Add --help option.
	  bc/scan.l: Print illegal, non-printable characters in octal.

Fri Sep  8 09:36:54 2000  Phil Nelson  <phil@cs.wwu.edu>

	* bc/bc.y: Allow more newlines in function definitions.
	  bc/proto.h: Don't prototype main.

Fri Sep  1 16:09:50 2000  Phil Nelson  <phil@cs.wwu.edu>

	* bc/bc.y: Spelling correction
	  bc/execute.c: Correct expressions for multi-byte names.
	  bc/load.c: Add parens for correct casting.
	  doc/bc.1: Typos.
	  Above fixes pointed out by kwzh@gnu.org (Karl Heuer).

Tue Aug 29 23:03:30 PDT 2000 Phil Nelson  <phil@cs.wwu.edu>

	* lib/testmul.c: #ifdef out a declaration matching #ifdef out
	  code.

Mon Jul 31 07:01:42 2000 Ken Pizzini <ken@gnu.org>

	* dc/numeric.c: use of the "n" command can cause a number to be printed
	  without a trailing newline, which would cause the column counter to
	  fail to be reset and result in inappropriately wrapped numeric outputs.
	  Fixed by always clearing the column counter before outputting each number.

	* dc/stack.c: if a stack is used without ever using the correspondingly
	  named register, it is perfectly legitimate for the register to be
	  uninitialized; added an "else if" to handle this case without aborting.

	* dc/eval.c: updated the comment explaining the restrictions
	  on the | command to better reflect reality.

	* doc/dc.texi: update the FSF office address in the copyright notice

Thu Jul 13 18:13:00 2000 Phil Nelson  <phil@cs.wwu.edu>

	* README: note --with-libedit configure parameter.

Tue Jun 20 22:52:10 2000  Phil Nelson  <phil@cs.wwu.edu>

	* bc/bcdefs.h: Include <readline/history.h> to quiet warnings.

	* configure.in: make --with-readline and --with-libedit work correctly.

	* Makefile.am: use $(MAKE) instead of directly calling make.

	* lib/testmul.c: Update to use bc_ on all number.c routines.

Sat Jun 10 22:44:29 2000  Phil Nelson  <phil@cs.wwu.edu>

	* bc/Makefile.am: Add scan.c to maintainer-clean target.

	* acconfig.h configure.in stamp-h.in bc/Makefile.am bc/execute.c
	  bc/fix-libmath_h bc/global.c bc/load.c bc/main.c bc/storage.c:
	    Remove long string for libmath.  Clean up for compiler errors.

	* dc/numeric.c: Correct parameter name.

Wed May 10 15:51:16 2000  Phil Nelson  <phil@cs.wwu.edu>

	* {bc,doc,dc,lib}/Makefile.am: Add Makefile.in to maintainer-clean.

	* bootstrap.sh: Added script to run the auto* tools.

	* Imported all into CVS tree.

Sun 2000-05-07  Phil Nelson  <phil@cs.wwu.edu>

	* bc/Makefile.am, dc/Makefile.am, lib/Makefile.am: Add -Wall to CFLAGS.

	* bc/{execute.c,proto.h,storage.c,util.c}, dc/numeric.c: Changes for
	  -Wall and for name changes in lib/number.c.  (Added bc_ to several
	  routine.  Updated copyright notice.)

	* h/number.h, lib/number.c:  Now comes from bcmath library which is
	  distributed in a different place.

Wed Mar 29 17:47:34 2000  Phil Nelson  <phil@cs.wwu.edu>

	* bc/{bc.y,bcdefs.h,global.h,main.c,proto.h,scan.l,storage.c}:
	  Added BSD libedit support.  Generic support for both where possible.
	  Fixed bugs in readline support noticed during libedit addition.
	  Works with NetBSD-1.4.1 libedit.
	* doc/bc.1: Documented libedit addition.

Wed Mar 29 10:20:18 2000  Phil Nelson  <phil@cs.wwu.edu>

	* FAQ: Added this file.
	* Makfile.am: Added FAQ to distribution

Tue Mar 28 13:52:35 2000  Phil Nelson  <phil@cs.wwu.edu>

	* lib/number.c, h/number.h: Moved definitions so
	  number.c/number.h is a stand-alone "library".
	  Changed definition of out_num to not reference a global.
	* lib/testmul.c: updated #includes for number.h changes.
	* h/{bcdefs.h,const.h,global.h,proto.h} moved to
	  bc where they really belong.
	* bc/execute.c: Changed calls to out_num for correctness.
	* dc/numeric.c: Changed calls to out_num for correctness,
	  include only number.h now and not all the other junk.
	* configure.in, acconfig.h: Start of support for BSD libedit,
	  added --with-pkg for NetBSD /usr/pkg tree.

Tue Mar 28 11:20:00 2000  Phil Nelson  <phil@cs.wwu.edu>

	* Test/{exp.b,fact.b,jn.b,mul.b,raise.b}: Tweeks on the tests
	  run to do more computation and test the recursive multiply.
	* bc/scan.l: Removed a printf('\r') that was unneeded.

Mon Mar 27 14:00:00 2000  Phil Nelson  <phil@cs.wwu.edu>

	* NEWS: Updated for 1.06.
	* lib/number.c, h/number.h: Fixed bugs in recursive multiply.
		Changed these files to be under the LGPL.
	* Tests/jn.b: Added more tests.
	* lib/Makefile.am: Only generate a timed version of number.o if
		requested.
	* README: Updated with information on how to generate a timed
	        version of number.o.
	* h/version.h: Updated copyright and version number for dc.

Thu Mar 16 14:01:45 2000  Phil Nelson  <phil@cs.wwu.edu>

	* doc/bc.1, doc/dc.1, doc/dc.texi: Changed bug reporting address
	  to bug-bc@gnu.org to update with what we hope will be reality.

Tue Feb  8 08:54:19 2000  Phil Nelson  <phil@cs.wwu.edu>

	* doc/bc.1, bc/util.c: Removed "multiply digits"
	  limit due to new recursive algorithm that doesn't
	  have those limits.

Tue Feb  8 08:47:05 2000  Phil Nelson  <phil@cs.wwu.edu>

	* lib/Makefile.am, lib/testmul.c, lib/number.c, Makefile.am:
	  Finally got a resonable version of the program
	  to test the crossover between non-recursive and
	  recursive multiply algorithms.  Added to distribution
	  and build process.  Does increase build time by
	  about 10 minutes.

Wed Oct  6 13:28:59 1999  Phil Nelson  <phil@cs.wwu.edu>

	* lib/Makefile.am: Added rules to allow DEFSADD definitions.

Sat Oct  2 19:59:51 1999  Phil Nelson  <phil@cs.wwu.edu>

	* bc/libmath.b: Correctly do the cosine accuracy.

Fri Oct  1 12:41:51 1999  Phil Nelson  <phil@cs.wwu.edu>

	* lib/number.c: Increase accuracy of computing raise.
	  Also turn off use of recursive multiply routines
	  until furthur testing.
	* bc/libmath.b: Increase accuracy of cosine.
	* bc/Makefile.am: Remove -lfl from items to make.

Wed Jul 28 10:29:28 1999  Phil Nelson  <phil@cs.wwu.edu>

	* bc/scan.l:  rl_len from char to int.  (From FreeBSD
	  bug tracking system and Nick Hibma <nick.hibma@jrc.it>)

Tue Jun 22 08:00:28 1999  Phil Nelson  <phil@cs.wwu.edu>

	* lib/number.c: Rewrote bc_multiply to use a faster
	  algorithm.  Old code not removed yet.

Mon Jun 21 03:08:02 1999  Phil Nelson  <phil@cs.wwu.edu>

	* h/version.h: Updated version number to 1.06.
	  bc/bc.y: Corrected bug in for statement, not popping.
	  bc/execute.c: Improved stack dump/instruction tracing.

Tue Jun 15 22:30:42 1999  Phil Nelson  <phil@cs.wwu.edu>

	* configure.in: Updated bc version to 1.06.

Tue Jun 15 22:27:44 1999  Phil Nelson  <phil@cs.wwu.edu>

	* h/bcdefs.h, h/const.h, bc/execute.c, bc/load.c, bc/storage.c,
	  bc/util.c: Removed segmented function storaged.  Now
	  dynamically expands (by doubling, starting at 1024 bytes)
	  to allow arbitrary sized functions.

Thu Jun 10 22:33:44 1999  Phil Nelson  <phil@cs.wwu.edu>

	* bc/libmath.b: change scaling in computation of j(n,x) so
	  it correctly computes the value.

Wed Jun 10 10:10:10 1998 Release of bc-1.05a.

Fri Apr 17 10:40:59 1998  Phil Nelson  <phil@cs.wwu.edu>

	* bc/main.c: Enable readline only if interactive.

Thu Apr 16 16:49:22 1998  Phil Nelson  <phil@cs.wwu.edu>

	* bc/configure.in: Tweeking of AM_PROG_LEX and associated
	  special case goo for solaris.

Sat Mar 28 21:43:18 1998  Phil Nelson  <phil@cs.wwu.edu>

	* bc/Makefile.am: Added "YFLAGS = -d" to get bc.h to build properly.

Mon Mar  9 12:54:42 PST 1998  Ken Pizzini <ken@halcyon.com>

	* doc/dc.texi, doc/dc.1: correct some documentation bugs.

Sun Mar  8 23:56:24 PST 1998  Ken Pizzini <ken@halcyon.com>

	* dc/numeric.c: eliminate superfluous variable from dc_dump_num();
	  annotate unused parameters in dc_add() and dc_sub().

	* h/version.h: change dc version number to 1.2 for release.

Sun Mar  8 21:13:50 1998  Phil Nelson  <phil@cs.wwu.edu>

	* bc/main.c: Applied patch from Ken Pizzini to force line
	  mode buffering on stdout.

Tue Jan  6 09:15:04 PST 1998  Ken Pizzini <ken@halcyon.com>

	* h/version.h: dc is now up to version 1.1.5.

	* dc/eval.c, dc/numeric.c, doc/dc.texi, doc/dc.1: once again
	  changed the behavior of the 'P' command with a numeric argument
	  to make it more general.  It now dumps out the *whole* number
	  (or rather, the whole of its positive integer portion) as a
	  byte stream.  (For small values this is still the same as 'aP'.)

	* dc/dc-proto.h, dc/dc.h, dc/eval.c, dc/misc.c, dc/numeric.c,
	  dc/stack.c, dc/string.c: Changed most uses of dc_boolean to
	  either dc_discard or dc_newline, and instances of DC_TRUE and
	  DC_FALSE to appropriate instances of DC_TOSS, DC_KEEP, DC_NONL,
	  or DC_WITHNL so that the code self-documents a little better.

Sun Jan  4 15:39:46 PST 1998  Ken Pizzini <ken@halcyon.com>

	* dc/eval.c, doc/dc.texi, doc/dc.1: Changed the functionality
	  of the 'P' command, and added the 'n' command.  Due to
	  a quirk of the implementation of traditional dc, some
	  people have come to expect that the 'P' command on a
	  numeric argument in the range of 1 to 99 should output
	  the corresponding character, despite the fact that this
	  usage can have very weird results for numbers outside
	  that range.  This functionality is why the 'a' command
	  was introduced last March, but people really want it to
	  "just work" without needing to use the 'a' command.
	  Bowing to this demand, the 'P' command now does the
	  equivalent of "aP" if the argument is numeric, and the
	  'n' command has been added to support the previous
	  functionality of the 'P' command.

	* dc/misc.c, dc/eval.c, dc/stack.c, dc/dc-proto.h:
	  Changed prototype for dc_print().  It now additionally
	  takes two flags, newline_p and discard_p, which it
	  passes through to dc_out_num() and dc_out_str() as
	  needed.

	* h/version.h: dc is now up to version 1.1.4.

Sat Sep 27 13:48:53 1997  Ken Pizzini <ken@halcyon.com>

	* h/version.h: dc is now up to version 1.1.3.

	* dc/stack.c, dc/array.c, dc/dc-proto.h, doc/dc.texi, doc/dc.1:
	  It has come to my attention that, though undocumented,
	  traditional dc stacked its arrays in parallel with the
	  stacking of simple registers.  I have now duplicated
	  this functionality.

	* dc/dc.c, configure.in: line-buffer dc's output if setvbuf()
	  is supported.  This was requested to simplify using dc as
	  an inferior process under emacs.

Fri Sep 26 19:56:15 1997  Ken Pizzini <ken@halcyon.com>

	* dc/dc.c: fixed bug reporting address for --help.

	* doc/dc.1, doc/dc.texi: corrected documentation of the maximum
	  admissible input base.

	* doc/dc.texi: corrected sample code equivalence for the | command.

	* lib/number.c: added a warning for non-zero scale in the base
	  for bc_raisemod().

Fri Sep 26 18:15:31 1997  Ken Pizzini <ken@halcyon.com>

	* dc/eval.c, doc/dc.1, doc/dc.texi: added !=, !<, and !> commands.

	* dc/eval.c: eliminated double-free in 'a' command.

	* dc/dc.c: changed placment of check for filename "-" so that
	 "-f -" will work.

	* h/version.h: updated dc version to 1.1.2.

Thu Sep 18 17:41:10 1997  Ken Pizzini <ken@halcyon.com>

	* dc/eval.c: fixed off-by-one error for Q and q commands.

	* dc/dc.c: added missing f: to third argument of getopt().

	* h/version.h: updated dc version to 1.1.1.

Thu May 22 08:24:08 1997  Phil Nelson  <phil@cs.wwu.edu>

	* lib/number.c(bc_sqrt): Fixed a bug that computed 0 for sqrt
	  of most numbers less than .000001.

Thu May  1 10:41:38 1997  Phil Nelson  <phil@cs.wwu.edu>

	* Test/timetest: change path to bc executable.

Wed Apr 30 12:00:00 1997  Phil Nelson  <phil@cs.wwu.edu>

	* Froze bc-1.04, started new directory for bc-1.05.
	  Fixes to bc-1.04 will be distributed as bc-1.05.

Mon Apr 21 14:57:14 1997  Phil Nelson  <phil@cs.wwu.edu>

	* bc/scan.l: Changed rules for single line comment to work
	  with lex as well as flex.  Also, do not include \n in the
	  comment.

	* doc/bc.1: Clarified the single line comment and that \n
	  is processed outside of the comment.

Sun Apr 20 22:21:30 1997  Phil Nelson  <phil@cs.wwu.edu>

	* bc/scan.l: Added rules for a single line comment starting
	  with the # character.

	* doc/bc.1: Documented the single line comment.

	* bc/Makefile.am: Added DISTCLEANFILES for proper clean up.

Sat Apr 19 22:08:05 1997  Phil Nelson  <phil@cs.wwu.edu>

	* dc/Makefile.am: Removed file from distribution list.

	* h/version.h: Updated dc version to 1.1.

Fri Apr 18 16:43:04 1997  Phil Nelson  <phil@cs.wwu.edu>

	* lib/number.c (bc_add, bc_sub) Added 1 to the length
	  of the memset call to make sure it zeroed all the
	  storage.

Fri Apr 18 13:58:56 1997  Phil Nelson  <phil@cs.wwu.edu>

	* configure.in: Tweeks to get things right.  Not sure if things
	  changed much.  Still working with autoconf/automake to do
	  the right thing.

Wed Apr 16 16:49:17 1997  Phil Nelson  <phil@cs.wwu.edu>

	* bc/main.c (main): Changed processing of BC_ENV_ARGS.

	* bc/main.c (parse_args): Removed "start" parameter.

Tue Apr 15 13:21:28 1997  Phil Nelson  <phil@cs.wwu.edu>

	* acconfig.h: Included support for PACKAGE and VERSION.

	* configure.in: More tweeks for automake support.

	* h/number.h: Improve definition of MIN and MAX.

	* doc/bc.1: Changed copyright, tweeked other text, added
	  e-mail address for bugs.

	* doc/dc.1: Added copyright and GPL license information,
	  Changed a few .SH formats.

Fri Apr 11 16:14:42 1997  Phil Nelson  <phil@cs.wwu.edu>

	* Makefile.am configure.in doc/Makefile.am lib/Makefile.am
	  bc/Makefile.am bc/bc.y dc/Makefile.am: Changes to accomodate
	  automake-1.1n (pre-release version of automake 1.2).

	* bc/bc.y bc/sbc.y: Changes to make sure tokens are numbered the
	  same in bc/bc.h and bc/sbc.h.

	* bc/scan.l: Changes for automake's naming convention.

	* NEWS: Fixed a typo.

Thu Apr 10 14:42:55 1997  Phil Nelson  <phil@cs.wwu.edu>

	* bc/{execute.c, global.c, libmath.b, load.c, main.c, sbc.y
	  scan.l, storage.c, util.c}:  Changed copyright comment and
	  added 1997 to copyright years.

	* h/{bcdefs.h, const.h, global.h, number.h proto.h, version.h}:
	  Changed copyright comment and added 1997 to copyright years.

	* h/version.h: Changed bc version to 1.04.

	* lib/number.c: Changed copyright comment and added 1997 to
	  copyright years.

	* lib/vfprintf.c: Noted that this was only for minix.

	* NEWS, README: README is now comp.sources.reviewed readme only.
	  NEWS now lists changes from version to version.

Thu Apr 10 13:41:56 1997  Phil Nelson  <phil@fawn.cs.wwu.edu>

	* Makefile.am: Removed FIXME stuff.

Thu Apr 8 13:39:53 1997  Phil Nelson  <phil@cs.wwu.edu>

	* bc/Makefile.am: Remove files that should not be distributed.

Mon Apr  7 17:14:28 1997  Phil Nelson  <phil@cs.wwu.edu>

	* Makefile.am: Removed Misc directory from distribution.

Mon Apr  7 16:16:01 1997  Phil Nelson  <phil@cs.wwu.edu>

	* bc/sbc.y: Corrected use of nextarg().

Tue Mar 25 19:32:28 1997  Ken Pizzini  <ken@halcyon.com>

	* dc/eval.c, dc/misc.c, dc/stack.c, dc/string.c,
	  dc/dc.h, dc/dc-proto.h, dc/dc.c, dc/numeric.c,
	  doc/dc.texi: updated years in copyright
	  notices.

	* dc/dc.1: updated last-revision date.

Tue Mar 25 16:35:46 1997  Ken Pizzini  <ken@halcyon.com>

	* lib/number.c: give a run-time warning in bc_raisemod()
	  if the modulus does not appear to be an integer.

	* doc/dc.texi, doc/dc.1: documented a warning against
	  the use of the new | command in conjunction with a
	  non-integral modulus.

Tue Mar 25 15:36:04 1997  Ken Pizzini  <ken@halcyon.com>

	* dc/string.c: dc_out_str() updated to use fwrite()
	  instead of printf(), to allow for the existence of
	  a NUL character in the string.

Tue Mar 25 13:42:51 1997  Ken Pizzini  <ken@halcyon.com>

	* doc/dc.texi, doc/dc.1: added documentation for new | command.

Tue Mar 25 13:19:55 1997  Ken Pizzini  <ken@halcyon.com>

	* dc/dc-proto.h: added prototype for dc_triop().

Tue Mar 25 12:00:38 1997  Ken Pizzini  <ken@halcyon.com>

	* lib/number.c: add bc_modexp() modular-exponentiation function.

	* h/proto.h: add prototypes for bc_modexp() and bc_divmod().

Tue Mar 25 09:07:13 1997  Ken Pizzini  <ken@halcyon.com>

	* doc/dc.texi, doc/dc.1: updated documentation with the
	  new command-line options.

	* doc/dc.texi, doc/dc.1: updated documentation with the
	  new '~', 'r', and 'a' commands.

	* dc/dc.c: added bug reporting information to --version text.

